             .title        "Sunsoft-4 Plugin"


;11/22/07
;Written by BootGod

;vectors for standard system calls    
send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

address:       .equ 00e0h
address_lo:    .equ 00e0h
address_hi:    .equ 00e1h
curbank:    .equ 00e2h
banksleft:    .equ 00e3h
bank0crc:  .equ 00e4h

reg:       .equ 00e8h
reg_lo:    .equ 00e8h
reg_hi:    .equ 00e9h

numpages_lo .equ 00eah
numpages_hi .equ 00ebh


temp_crc:    .equ 00ech

;plugin header defines
p_ver: = 1	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Sunsoft-4 Carts"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 128 >> 4,0 >> 4
             .db 128 >> 3,0 >> 3
             .db 8,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here

             
             lda #4
             jsr send_byte

;Set up for PRG transfer

prg_info:    lda #0		;128K PRG
             jsr send_byte
             lda #2
             jsr send_byte
             lda #1		;send type is PRG
             jsr send_byte

             lda #8		;# of 16K banks
             sta banksleft
             lda #8
             sta curbank

set_prg:     lda curbank
             sta 0f000h		;write bank num to PRG select register ($F000)
             inc curbank
             lda #0		;set read address to $8000
             sta address_lo
             lda #080h
             sta address_hi

             ldx #64		;set counters for 16K bank xfer
             ldy #0

send_prg:    lda (address),y
             jsr send_byte
             iny
             bne send_prg
             inc address_hi
             dex
             bne send_prg
             dec banksleft
             bne set_prg	;16K has been sent, load next bank
             
;Set up for CHR transfer
                         
chr_info:    lda #0		;128K CHR
             jsr send_byte
             lda #2
             jsr send_byte
             lda #2		;send type is CHR
             jsr send_byte

             lda #64		;# of 2K banks
             sta banksleft
             lda #0
             sta curbank

set_chr:     lda curbank
             sta 08000h		;write bank num to CHR select ($8000)

             lda #0		;init ppu read
             jsr wr_ppu
             lda 2007h

             ldx #8		;set counters for 2K bank xfer
             ldy #0

send_chr:    lda 2007h
             jsr send_byte
             iny
             bne send_chr
             dex
             bne send_chr
             inc curbank
             dec banksleft
             bne set_chr	;2K has been sent, load next bank

;check for WRAM
             lda #10h
             sta 0f000h
do_wram:     jsr chk_wram
             bne done
             lda #020h
             tax
             jsr send_byte
             lda #0
             jsr send_byte
             lda #3
             jsr send_byte
             lda #0
             sta address_lo
             tay
             lda #060h
             sta address_hi
            
send_wram:   lda (address),y
             jsr send_byte
             iny
             bne send_wram
             inc address_hi
             dex
             bne send_wram

;Signal client no more is coming

done:        lda #0
             jsr send_byte
             lda #0
             jsr send_byte
             lda #0
             jsr send_byte

             rts

             .fill 0800h-*,0ffh	;fill rest to get 1K of data

             .end
